package controller;

import java.util.Collection;
import java.util.Date;



/*
 * Created on 30.11.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author roy.holliger
 * 
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

public interface System {

	/** 
	 * Die Suche ohne Suchkriterien. Mit dieser Methode ist ein Suchen
	 * mglich ohne Suchkriterien auszuwhlen. Die Methode liefert alle im
	 * System gespeicherten Notizen zurck.
	 */
	public Collection search();
	
	/**
	 * Die Suche nach dem Autor. Mit dieser Methode ist ein Suchen nach
	 * dem Nick eines Autors mglich. Die Methode liefert eine Liste aller
	 * Notizen vom gesuchten Autor zurck.
	 */
	public Collection searchAuthor(String author);
	
	/**
	 * Die Suche nach dem Titel. Mit dieser Methode ist ein Suchen nach
	 * dem Titel einer Notiz mglich. Die Methode liefert eine Liste aller
	 * Notizen mit dem gesuchten Titel zurck.
	   */
	public Collection searchTitle(String title);
	
	/**
	 * Die Suche nach Stichwrtern. Mit dieser Methode ist ein Suchen
	 * nach Stichwrtern mglich. Die Methode liefert eine Liste aller
	 * Notizen mit den entsprechenden Stichwrtern zurck.
	 */
	public Collection searchKeyword(String[] keyword);
	
	/**
	 *  Die Suche nach Volltext. Mit dieser Methode ist ein Volltextsuchen
	 *  mglich. Die Methode liefert eine Liste aller Notizen zurck, welche
	 * mit der Volltextsuche bereinstimmen.
	 */
	public Collection searchFull(String[] volltext);
	
	/**
	 * Die Suche nach nderungsdatum. Mit dieser Methode ist ein Suchen
	 * nach dem nderungsdatum mglich. Die Methode liefert eine Liste
	 * aller Notizen mit dem entsprechenden nderungsdatum zurck.
	 */
	public Collection searchChangeDate(Date datum);
	
	/**
	 * * Diese Methode wird aufgerufen, wenn eine NEUE Notiz gespeichert
	 * werden muss.
	 * @return Wenn true zurckgeliefert wird, wurde die Notiz korrekt gespeichert.
	 */
	public boolean createNote(Note note);
	
	/**
	 * 	 * * Diese Methode wird aufgerufen, wenn eine bereits vorhandene Notiz gespeichert
	 * werden muss.
	 * @return Wenn true zurckgeliefert wird, wurde die Notiz korrekt gespeichert.
	 */
	public boolean save(Note note);
	
	/**
	 * Diese Methode wird aufgerufen, wenn eine Notiz geloescht werden
	 * muss.
	 * @return Wenn true zurckgeliefert wird, wurde die Notiz korrekt gelscht.
	 */
	public boolean delete(Note note);
	
	/**
	 * Diese Methode wird aufgerufen, wenn ein neuer User erstellt werden soll.
	 * @return Wenn true zurckgeliefert
	 */
	public boolean createUser(User user);
	
	/**
	 * Dient zum berprfen ob User in der Datenbank vorhanden ist.
	 * @return Wenn User vorhanden ist, wird das Userobjekt zurckgegeben. 
	 * Ansonsten wird null zurckgegeben.
	 */
	public User login(String nick, String password);
	
	

}
