SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Datenbank: `db_notizverwaltung`
--

DROP DATABASE `db_notizverwaltung`;

CREATE DATABASE `db_notizverwaltung` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
USE db_notizverwaltung;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `category`
--

CREATE TABLE IF NOT EXISTS `category` (
  `CategoryID`	int(10)	unsigned NOT NULL auto_increment,
  `ParentID`	int(10)	unsigned default NULL,
  `Name`		text		NOT NULL,
  PRIMARY KEY  (`CategoryID`),
  KEY `FK_ParentID` (`ParentID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;


-- --------------------------------------------------------

--
-- Constraints der Tabelle `category`
--

ALTER TABLE `category`
  ADD CONSTRAINT `FK_ParentID` FOREIGN KEY (`ParentID`) REFERENCES `category` (`CategoryID`) ON DELETE CASCADE ON UPDATE CASCADE;
  
  
-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `noteversion`
--

CREATE TABLE IF NOT EXISTS `noteversion` (
  `NoteID`		int(10)	unsigned NOT NULL,
  `VersionID`	int(10)	unsigned NOT NULL,
  `Title`		text		NOT NULL,
  `Author`		int(10)	unsigned NOT NULL,
  `Text`		text		NOT NULL,
  `Date`		datetime	NOT NULL,
  `Keyword`		text		NOT NULL,
  `IsNewest`	tinyint(1)	NOT NULL,
  PRIMARY KEY  USING BTREE (`NoteID`,`VersionID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 PACK_KEYS=1;


-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `user`
--

CREATE TABLE IF NOT EXISTS `user` (
  `UserID`		int(10)		unsigned NOT NULL auto_increment,
  `Nickname`	varchar(45)		NOT NULL,
  `Password`	varchar(45)		NOT NULL,
  PRIMARY KEY  (`UserID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;


-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `note_category`
--

CREATE TABLE IF NOT EXISTS `note_category` (
  `FK_NoteID`			int(11) NOT NULL,
  `FK_CategoryID`		int(11) NOT NULL,
  `FK_NoteVersionID`	int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
