package controller;

import gui.Resources;

import javax.swing.AbstractAction;
import javax.swing.Action;

/*
 * Created on 12.10.2007
 */

public abstract class AbstractNoteAction extends AbstractAction {

	String keyName;

	public AbstractNoteAction(String key) {
		keyName = key;

		this.putValue(Action.NAME, Resources.getString(keyName +"Action"));
		this.putValue(Action.MNEMONIC_KEY, new Integer(this.getMnemonic(keyName)));
	}
	public AbstractNoteAction(String key, boolean hasImage) {
		this(key);
		if (hasImage) {
			this.putValue(Action.SMALL_ICON, ResourceAnchor.getImageIcon(keyName+".gif"));
		}
	}

	private int getMnemonic(String action){
		return Resources.getString(action + "Action.mnemonic").charAt(0);	
	}

	public String getKeyName() {
		return keyName;
	}
	public void setKeyName(String keyName) {
		this.keyName = keyName;
	}
}
