package controller;

import gui.CreateSaveInterface;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import model.ModelImplementation;
import model.ModelInterface;
import model.Note;

/*
 * Kreiert eine neue Notiz, somit kommt es nicht in Konflikt mit dem Speichern!
 * Das heisst es muss auch nicht berprft werden ob schon etwas vorhanden ist, sondern 
 * es wird einfach immer eine neue Notiz angelegt!
 */

@SuppressWarnings("serial")
public class CreateAction extends AbstractNoteAction{
	
	CreateSaveInterface csi;

	public CreateAction(){
		super("create", true);
	}
	
	public void setCreateSaveInterface(CreateSaveInterface createSave){
		csi = createSave;
	}
	
	public void actionPerformed(ActionEvent ae) {
		Note nv = new Note();
		copyProperties(nv);
		ModelInterface model = ModelImplementation.getInstance();
		model.saveNote(nv);
		
		reset(ae);
	}

	private void reset(ActionEvent ae) {
		Action resetAction = ActionMap.getAction("reset");
		ResetAction ra = (ResetAction) resetAction;
		ra.actionPerformed(ae);
	}

	private void copyProperties(Note nv) {
		nv.setTitle(csi.getTitle());
		nv.setFullText(csi.getNote());
		nv.setKeyword(csi.getKeyword());
		nv.setAuthor(csi.getAuthor());
	}
}
