package controller;

import gui.MainGuiFrame;
import gui.SearchResultNote;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import model.ModelImplementation;
import model.ModelInterface;
import model.Note;
import model.SearchCriteria;

@SuppressWarnings("serial")
public class DeleteFromTableAction extends AbstractNoteAction{

	@SuppressWarnings("unused")
	private Note myNote;
	private SearchResultNote mySearchResultNote;

	public DeleteFromTableAction(){
		super("deleteFromTable");
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void saveNoteVersion(Note myNote){
		this.myNote = myNote;
	}

	@SuppressWarnings("unchecked")
	public void actionPerformed(ActionEvent ae) {

		ArrayList<Integer> myIndex = mySearchResultNote.getIndexes();

//		System.out.println("Size of myIndex" +myIndex.size());
		DeleteOptionPaneAction myOptionPaneAction = new DeleteOptionPaneAction();

		for (int i = 0; i < myIndex.size(); i++) {
			int numberFromMyIndex = myIndex.get(i);
			Note myNote = mySearchResultNote.getNoteVersionObject(numberFromMyIndex);
			myOptionPaneAction.saveNoteRef(myNote);
			myOptionPaneAction.actionPerformed(ae);
		}
		
		ModelInterface model = ModelImplementation.getInstance();
		MainGuiFrame mainGui = mySearchResultNote.getMainGuiReference();
		SearchCriteria sc = mySearchResultNote.getSearchCriteria();
		mainGui.removeActiveTab(mySearchResultNote);
		
		mySearchResultNote = new SearchResultNote(mainGui, sc, model.searchNote(mySearchResultNote.getSearchCriteria()));
	}
	
	public void setSearchResultNoteReference(SearchResultNote note) {
		mySearchResultNote = note;	
	}
}
