/*
 * Name: Action.java
 * Version: 1.0
 * Beschreibung: Die Interfaceklasse Action.java, die als Default Action dient.
 * 
 */
package controller.web;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import model.ModelInterface;
import model.Note;

public abstract class Action {
	
	public abstract String execute(HttpServletRequest request, HttpServletResponse response);

	protected void fillNoteObject(HttpServletRequest request, Note noteObject, ModelInterface mi, boolean bool) {
		noteObject.setTitle(request.getParameter("title"));
		noteObject.setFullText(request.getParameter("fullText"));
		noteObject.setKeyword(request.getParameter("keyword"));
		noteObject.setDate(new Date());
		String username = (String) request.getSession().getAttribute("username");
		noteObject.setAuthor(username);
		noteObject.setAuthorID(mi.getUserIDByUsername(username));
		noteObject.setSingleCategoryID(Integer.parseInt(request.getParameter("categoryList")));
		
		// SearchCreateNoteAction 	--> bool = true
		// SaveNoteAction 			--> bool = false
		if(bool)
		{
			noteObject.setVersionID(Integer.parseInt(request.getParameter("version")));
			noteObject.setDBID(Integer.parseInt(request.getParameter("DBID")));
		}
		else
		{
			Note sessionNote = (Note) request.getSession().getAttribute("actualNote");
			noteObject.setVersionID(sessionNote.getVersionID());
			noteObject.setDBID(sessionNote.getDBID());
		}
		
		request.getSession().setAttribute("actualNote", noteObject);
	}
}
