/*
 * Name: DeleteNoteAction.java
 * Version: 1.0
 * Beschreibung: Die Klasse DeleteNoteAction.java, die nach showNote.jsp und searchResult.jsp
 * aufgerufen wird und dazu dient, ein Notizobjekt zu l�schen.
 * 
 */
package controller.web;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import model.ModelImplementation;
import model.ModelInterface;
import model.Note;
import model.SearchCriteria;

public class DeleteNoteAction extends Action {
	
	public String execute(HttpServletRequest request, HttpServletResponse response) {

		ModelInterface mi = ModelImplementation.getInstance();
		mi.setNoteInactive(Integer.parseInt(request.getParameter("DBID")));
	
		if (request.getSession().getAttribute("searchCriteria") != null) {
			Collection<Note> searchResults = mi.searchNote((SearchCriteria) request.getSession().getAttribute("searchCriteria"));
			request.setAttribute("searchResult", searchResults);
			return "searchResultNote";
		}
		else {
			return HomeAction.staticHomeMethod(request);
		}
	}
}