/*
 * Name: SaveNoteAction.java
 * Version: 1.0
 * Beschreibung: Die Klasse SaveNoteAction.java, die nach editNote.jsp aufgerufen wird
 * und dazu dient, eine ge�nderte Nachricht abzuspeichern.
 * 
 */
package controller.web;


import java.util.Date;
import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import model.ModelImplementation;
import model.ModelInterface;
import model.Note;

public class SaveNoteAction extends Action {

	public String execute(HttpServletRequest request, HttpServletResponse response) {
		if(request.getParameter("cancel") != null){
			return "showNote";
		}
		else if (request.getParameter("iseditnote") != null) {
			return saveEditedNote(request);
		}
		else {
			return "home";
		}
	}

	private String saveEditedNote(HttpServletRequest request) {
		Note noteObject = new Note();
		ModelInterface mi = ModelImplementation.getInstance();
		
		fillNoteObject(request, noteObject, mi, false);

		if (neededFieldsFilledIn(noteObject)) {
			mi.saveNote(noteObject);
			return "showNote";
		}
		else {
			HashMap<String, String> errorMap = handleEmptyFields();
			return handleError(request, errorMap);
		}
	}

//	private void fillNoteObject(HttpServletRequest request, Note noteObject, ModelInterface mi, boolean bool) {
//		noteObject.setTitle(request.getParameter("title"));
//		noteObject.setFullText(request.getParameter("fullText"));
//		noteObject.setKeyword(request.getParameter("keyword"));
//		noteObject.setDate(new Date());
//
//		String username = (String) request.getSession().getAttribute("username");
//		noteObject.setAuthor((String) request.getSession().getAttribute("username"));
//		noteObject.setAuthorID(mi.getUserIDByUsername(username));
//
//		Note sessionNote = (Note) request.getSession().getAttribute("actualNote");
//		noteObject.setVersionID(sessionNote.getVersionID());
//		noteObject.setDBID(sessionNote.getDBID());
//		System.out.println(noteObject.getDBID());
//		System.out.println(noteObject.getVersionID());
//		request.getSession().setAttribute("actualNote", noteObject);
//	}

	private HashMap<String, String> handleEmptyFields() {
		HashMap<String, String> errorMap = new HashMap<String, String>();
		errorMap.put("createSearchErr", "Titel und/oder Text wurde(n) nicht ausgef&uuml;llt.");
		errorMap.put("title", "true");
		errorMap.put("text", "true");
		return errorMap;
	}

	private boolean neededFieldsFilledIn(Note noteObject) {
		return (!noteObject.getTitle().equals("") || !noteObject.getFullText().equals(""));
	}

	private String handleError(HttpServletRequest request, HashMap<String, String> errorMap) {
		if(errorMap.size() > 0) {
		request.setAttribute("errorMap", errorMap);
		return "editNote";
		}
		return "home";
	}

	


}