package gui;

import java.awt.GridBagConstraints;
import java.util.Date;


import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import model.Note;


/*
 * Created on 05.11.2007
 */

@SuppressWarnings("serial")
public class EditNote extends TabContent implements CreateSaveInterface {
	
	String author = System.getProperty("user.name");
	
	JLabel lKeyword = new JLabel(rb.getString("keyword"));
	JLabel lNote = new JLabel(rb.getString("note"));
	
	JTextField tfKeyword = new JTextField(20);

	JButton saveButton;
	
	public EditNote(MainGuiFrame refMainGui, Note refNote){ 
		super(refMainGui, refNote);
		
		createCategoryPanel();
		
		setTabName(refNote.getTitle());
		
		setComponentLayout();
		
		createButtonsForEditNote();
		
		addDocumentListenerToTextFields();
		
		mainGui.addNewTab(this);
	}

	private void addDocumentListenerToTextFields() {
		ChangeListener ch = new ChangeListener();
		tfTitle.getDocument().addDocumentListener(ch);
		tfKeyword.getDocument().addDocumentListener(ch);
		taNote.getDocument().addDocumentListener(ch);
	}

	private void createButtonsForEditNote() {
		/*Action saveAction = ActionMap.getAction("save");
		
			SaveAction sa = (SaveAction) saveAction;
			sa.setCreateSaveInterface(this);
			saveButton = new JButton(sa);
			addButton(saveButton); 
		*/
		saveButton.setEnabled(false);
	}

	private void setComponentLayout() {
		constraints.anchor = GridBagConstraints.SOUTHWEST;
		setComponent(constraints, 0, 0, 1, 1, lTitle);		
		setComponent(constraints, 1, 0, 1, 1, lKeyword);		
		setComponent(constraints, 0, 2, 1, 2, lNote);
		setComponent(constraints, 2, 0, 1, 1, lCategory);

		constraints.anchor = GridBagConstraints.NORTHWEST;
		setComponent(constraints, 0, 1, 1, 1, tfTitle);		
		setComponent(constraints, 1, 1, 1, 1, tfKeyword);
		
		constraints.fill = GridBagConstraints.BOTH;
		setComponent(constraints, 0, 3, 1, 2, new JScrollPane(taNote));
		setComponent(constraints, 2, 1, 3, 1, spCategory);
	}
	
	public void setContent(){
		tfTitle.setText(note.getTitle());
		tfKeyword.setText(note.getKeyword());
		taNote.setText(note.getFullText());
	}
	
	@Override
	public int smallLines() {
		return 3;
	}

	// Checks if Textfields has changed
	private class ChangeListener implements DocumentListener {
		
		public boolean hasChanged(){
			return !(tfTitle.getText().equals(note.getTitle()) &&
					tfKeyword.getText().equals(note.getKeyword()) &&
					taNote.getText().equals(note.getFullText()));
		}
		
		public void enableSaveButton(){
			saveButton.setEnabled(hasChanged());
		}

		public void changedUpdate(DocumentEvent arg0) {
			enableSaveButton();
		}

		public void insertUpdate(DocumentEvent arg0) {
			enableSaveButton();
		}

		public void removeUpdate(DocumentEvent arg0) {
			enableSaveButton();
		}
	}

	public String getAuthor() {
		return author;
	}

	
	public Object getCategory() {
		// TODO Auto-generated method stub
		return null;
	}

	public Date getDateFrom() {
		// TODO Auto-generated method stub
		return null;
	}

	public Date getDateTo() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getNote() {
		return taNote.getText();
	}

	public String getTitle() {
		return tfTitle.getText();
	}

	public String getKeyword(){
		return tfKeyword.getText();
	}


	public Note getNoteVersion() {
		return note;
	}
}
