package gui;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.JFrame;
import javax.swing.JPanel;

import controller.ResourceAnchor;

@SuppressWarnings("serial")
public class MainGuiFrame extends JFrame{

	JPanel toolbarPanel = new JPanel(new BorderLayout());
	TabButtonPanel tabButtonPanel = new TabButtonPanel();
		
	public MainGuiFrame(){
		setTitle(Resources.getString("applicationTitle"));
		setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		setIconImage(ResourceAnchor.getImageIcon(Resources.getString("icon")).getImage());
		NoteMenuBar nmb = new NoteMenuBar();
		setJMenuBar(nmb);
		NoteToolBar ntb = new NoteToolBar();
		toolbarPanel.add(ntb, BorderLayout.CENTER);
		this.add(tabButtonPanel);
		this.add(toolbarPanel, BorderLayout.NORTH);

		CreateNote createNote = new CreateNote(this);
		@SuppressWarnings("unused")
		SearchNote searchNote = new SearchNote(this);
		
		setActiveTab(createNote);

	}
	
	public void removeActiveTab(TabContent tabc){		//Aktuell angezeigter Tab
		tabButtonPanel.removeTab(tabc);
	}
	
	public void setActiveTab(TabContent tabc){
		tabButtonPanel.setActiveTab(tabc);			//TODO index selectedComponent
	}
	
	public void addNewTab(TabContent tabc){
		tabButtonPanel.addContent(tabc);
	}

	public SearchNote getSearchNote() {
		Component[] arr = tabButtonPanel.getComponents();
		
		for(int i= 0; arr.length > i; i++){
			if(arr[i] instanceof SearchNote){
				return (SearchNote) arr[i];
			} 
		}
		return null;
	}
	
		public void removeTab(TabContent tabc) {
		tabButtonPanel.removeTab(tabc);
	}
}
