package gui;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;

import model.Note;

public class SearchResultNote_TableModel implements TableModel {

	String headerName [];
	
	// Sprachabhngige Beschriftung
	String headerLabels[];

	// Datentyp
	Class<?> dataTypes[] = {String.class, String.class, String.class, String.class, String.class};

	// Daten
	@SuppressWarnings("unchecked")
	ArrayList<?> values = new ArrayList();

	public SearchResultNote_TableModel(ArrayList<?> data){
		values = data;
		
		initializeHeaderName();
		initializeHeaderLabels();
	}
	
	private void initializeHeaderName() {
		String tableColumns = Resources.getString("table.columns");
		
		StringTokenizer stokenizer = new StringTokenizer(tableColumns, ",");
		headerName = new String[stokenizer.countTokens()];
		for (int i = 0; stokenizer.hasMoreTokens(); i++) {
			String s = stokenizer.nextToken().trim();
			headerName[i] = s;
		}
	}

	private void initializeHeaderLabels() {
		headerLabels = new String[headerName.length];
		
		for (int i = 0; i < headerName.length; i++) {
			headerLabels[i] = Resources.getString("table.columnName."+ headerName[i]);
		}
	}

	public void sortByAttribute(String columnName){
	}

	public Class<?> getColumnClass(int columnIndex) {
		return dataTypes[columnIndex];
	}

	public int getColumnCount() {
		return headerName.length;
	}

	public String getColumnName(int columnIndex) {
		return headerLabels[columnIndex];
	}

	public int getRowCount() {
		return values.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		Note note = (Note) values.get(rowIndex);

		String getter = "get"+ headerName[columnIndex];

		return invoke(note, getter);
	}

	private String invoke(Note note, String getter) {
		try {
			Class<Note> noteclass = Note.class;
			Method method = noteclass.getMethod(getter);
			return (String) method.invoke(note);
		}
		catch (Exception e) {
			e.printStackTrace();
			return "NoSuchMethod Note."+ getter;
		}
	}

	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return false;
	}

	public void removeTableModelListener(TableModelListener l) {	}
	public void setValueAt(Object aValue, int rowIndex, int columnIndex) {	}
	public void addTableModelListener(TableModelListener l){	}

}
