/*
 * Created on 23.10.2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

@SuppressWarnings("serial")
public class TabButtonPanel extends JPanel implements ChangeListener {

	JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
	JTabbedPane tabbedPane = new JTabbedPane();

	public TabButtonPanel(){
		this.setLayout(new BorderLayout());
		this.add(buttonPanel, BorderLayout.SOUTH);
		this.add(tabbedPane, BorderLayout.CENTER);
		tabbedPane.addChangeListener(this);
	}

	private void addButton(JButton button) {
		buttonPanel.add(button);
	}

	public void addContent(TabContent tabc) {
		setButtons(tabc);
		tabbedPane.add(tabc.getTabName(), tabc);
		if(!(tabc instanceof SearchNote) && !(tabc instanceof CreateNote)){
			int cnt = tabbedPane.getComponentCount();
			cnt = tabbedPane.indexOfComponent(tabc);
			tabbedPane.setTabComponentAt(cnt , new ButtonTabComponent(tabbedPane));
			tabbedPane.setSelectedComponent(tabc);
		}
	}

	private void setButtons(TabContent tabc) {
		buttonPanel.removeAll();
		Collection<?> c = tabc.getButtons();
		Iterator<?> it = c.iterator();

		for(; it.hasNext();) {
			addButton((JButton) it.next());
		}
		buttonPanel.repaint();
	}

	public void setActiveTab(TabContent tabc) {
		tabbedPane.setSelectedComponent(tabc);
		setButtons(tabc);
	}

	public void stateChanged(ChangeEvent ce) {
		Object source = ce.getSource();
		JTabbedPane pane = (JTabbedPane) source;
		Component comp = pane.getSelectedComponent();
		TabContent activeContent = (TabContent) comp;

		this.setButtons(activeContent);
	}
	
	public void removeTab(TabContent tabc){
		tabbedPane.remove(tabc);
	}
}
