package model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;

import javax.swing.tree.TreeNode;

/*
 * Created on 12.10.2007
 */

public class Category implements TreeNode {

	private String name;
	private boolean isChecked;
	private int dbID;
	private Category parentCategory;
	private ArrayList<Category> childCategories = new ArrayList<Category>();
	
	public void addChild(Category child) {
		childCategories.add(child);
	}
	
	public void removeChild(Category child) {
		for (int i = 0; i < childCategories.size(); i++) {
			if (childCategories.get(i).equals(child)) {
				childCategories.remove(i);
				return;
			}
		}
	}
	public void removeChild(int index) {
		for (int i = 0; i < childCategories.size(); i++) {
			if (i == index) {
				childCategories.remove(i);
				return;
			}
		}
	}
	
	public void setCheck(boolean isChecked) {
		this.isChecked = isChecked;
	}

	public void removeAllChecks() {
		isChecked = false;
		for (int i = 0; i < childCategories.size(); i++) {
			((Category) childCategories.get(i)).removeAllChecks();
		}
		
	}
	public boolean isChecked() {
		return isChecked;
	}
	public void setChecked(boolean isChecked) {
		this.isChecked = isChecked;
	}

	public Enumeration<Category> children() {
		return Collections.enumeration(childCategories);
	}

	public boolean getAllowsChildren() {
		return true;
	}

	public TreeNode getChildAt(int index) {
		if (index < childCategories.size()) {
			return (Category) childCategories.get(index);
		}
		else {
			return null;
		}
	}

	public int getChildCount() {
		return childCategories.size();
	}

	public int getIndex(TreeNode node) {
		for (int i = 0; i < childCategories.size(); i++) {
			Category c = (Category) childCategories.get(i);
			if (c.equals(node)) {
				return i;
			}	
		}
		return -1;
	}

	public TreeNode getParent() {
		return parentCategory;
	}

	public boolean isLeaf() {
		return childCategories == null || childCategories.size() == 0;
	}
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	public Category getParentCategory() {
		return parentCategory;
	}
	public void setParentCategory(Category parentCategory) {
		this.parentCategory = parentCategory;
	}
	
	public int getDbID() {
		return dbID;
	}
	/**
	 * !!! Only use from sql Package !!!
	 * @param dbID
	 */
	public void setDbID(int dbID) {
		this.dbID = dbID;
	}

	public String toString() {
		return getName();
	}
}
