package model;

import java.util.Collection;

import sql.SQL;
import sql.SQLImplementation;

/*
 * Created on 12.10.2007
 */

public class ModelImplementation implements ModelInterface {

	private static ModelImplementation modelImpl;
	
	private ModelImplementation(){
		
	}
	
	public static ModelInterface getInstance(){
		if(modelImpl == null)
		{
			modelImpl = new ModelImplementation();
		}
		return modelImpl;
	}
	
	/* (non-Javadoc)
	 * @see model.ModelInterface#createNote(null)
	 */
	public boolean createNote(Note note) {
		return false;
	}

	/* (non-Javadoc)
	 * @see model.ModelInterface#searchNote(null)
	 */
	public Collection<Note> searchNote(SearchCriteria criteria) {
		SQL sql = SQLImplementation.getInstance();
//		System.out.println("Weiterleitung an SQL, Suche");
		return sql.searchNote(criteria);
		
	}

	/* (non-Javadoc)
	 * @see model.ModelInterface#createUser(null)
	 */
	public boolean createUser(User user) {
		return false;
	}

	/* (non-Javadoc)
	 * @see model.ModelInterface#deleteNote(null)
	 */
	public boolean deleteNote(Note note, boolean myBoolean) {
		SQL sql = SQLImplementation.getInstance();
		return sql.deleteNote(note, myBoolean);
	}
	
	public boolean setNoteInactive(int noteID){
		SQL sql = SQLImplementation.getInstance();
		return sql.setNoteInactive(noteID);
	}

	/* (non-Javadoc)
	 * @see model.ModelInterface#login(java.lang.String, java.lang.String)
	 */
	public User login(String nick, String pw) {
		return null;
	}

	/* (non-Javadoc)
	 * @see model.ModelInterface#saveNote(null)
	 */
	public int saveNote(Note note) {
		SQL sql = SQLImplementation.getInstance();
//		System.out.println("Weiterleitung an SQL, Speichern");
//		System.out.println(note.getTitle());
//		System.out.println(note.getFullText());
		return sql.saveNote(note);
	}

	public Category getRootCategory() {
		SQL sql = SQLImplementation.getInstance();
//		System.out.println("Get Category from DB");
		return sql.getRootCategory();
	}

	public boolean startDoLogin(String nickname, String password) {
		SQL sql = SQLImplementation.getInstance();
		return sql.doLogin(nickname, password);
	}
	
	public void startDoRegistration(String user, String password){
		SQL sql = SQLImplementation.getInstance();
		sql.doRegister(user, password);
	}

	public Note startGetSimpleNote(int noteID, int versionID) {
		SQL sql = SQLImplementation.getInstance();
		return sql.getSimpleNote(noteID, versionID);
	}

	public int getUserIDByUsername(String username) {
		SQL sql = SQLImplementation.getInstance();
		return sql.getUserIDByUsername(username);
	}

	public Collection getCategoryList() {
		SQL sql = SQLImplementation.getInstance();
		return sql.getCategoryList();
		
	}

}
