package sql;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;

import model.Category;
import model.SearchCriteria;

public class CategoryDAO extends DAO{

	public static final int ROOT_ID = 1;
	Connection c;
	
	private void addChildren(Category cat) {
		ResultSet rs = getResultSet("SELECT * FROM category WHERE ParentID = " + cat.getDbID() + " ");
		try {
			while(rs.next()){
				newCategory(cat, rs);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void newCategory(Category cat, ResultSet rs) throws SQLException {
		Category actCategory = new Category();
		actCategory.setName(rs.getString("Name"));
		actCategory.setDbID(rs.getInt("CategoryID"));
		actCategory.setParentCategory(cat);
		cat.addChild(actCategory);
		addChildren(actCategory);
	}
	
	public void updateCategory(Category cat) throws SQLException{
		c = this.getConnection();
		Statement stmt = c.createStatement();
		stmt.executeUpdate("UPDATE category SET Name = \"" + cat.getName() + "\", ParentID = " + cat.getParentCategory() + 
											" WHERE CategoryID = " + cat.getDbID());
		this.putConnection(c);
	}
	
	public void deleteCategoryRek(int id) throws SQLException{
		c = this.getConnection();
		Statement stmt = c.createStatement();
		stmt.execute("DELETE FROM category WHERE CategoryID = " + id);

		ResultSet rs = stmt.executeQuery("SELECT * FROM category WHERE ParentID = " + id);
		ArrayList <Integer> idArray = new ArrayList <Integer>();
		
		while(rs.next()){
			idArray.add(rs.getInt("CategoryID"));
		}
		
		for(int tempId : idArray){
			deleteCategoryRek(tempId);
		}
		this.putConnection(c);
	}

	public void deleteCategory(Category cat) throws SQLException{
		int id = cat.getDbID();
		this.deleteCategoryRek(id);
	}
	
	private Category readRootCategoryFromDB() {
		Category root = new Category();
		ResultSet rs = getResultSet("SELECT * FROM category WHERE CategoryID= " +   ROOT_ID + " ");
		try {
			rs.next();
			root.setName(rs.getString("Name"));
			root.setDbID(ROOT_ID);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return root;
	}

	public ResultSet getResultSet(String sql) {
		c = this.getConnection();
		ResultSet rs;
		try{		
			stmt = c.createStatement();
			rs = stmt.executeQuery(sql);
			return rs;
		} catch(SQLException ex){
			errorQuery(c, ex);
			return null;
		}
		finally{
			this.putConnection(c);
		}
	}

	public Category getRootCategory() {
		Category root = readRootCategoryFromDB();
		addChildren(root);
		
		return root;
	}

	public Collection getCategoryList() {
		c = this.getConnection();
		try{
			stmt = c.createStatement();
			ResultSet dbResult = stmt.executeQuery("SELECT Name, CategoryID FROM category");
			
			Collection<Category> categoryList = new ArrayList();
			
			while(dbResult.next()){
				if(!dbResult.getString("Name").equals("...")){
					Category category = new Category();
					category.setDbID(dbResult.getInt("CategoryID"));
					category.setName(dbResult.getString("Name"));
					categoryList.add(category);
				}
			}
			return categoryList;
			
			
		}catch(SQLException ex){
			errorQuery(c, ex);
			return null;
		}finally{
			this.putConnection(c);
		}
	}
}

