package sql;

import java.sql.Connection;
import java.util.Hashtable;
import java.util.ResourceBundle;


public class DBConnectionManager {

	static ResourceBundle rb =  ResourceBundle.getBundle("sql.DBServer");

	private static final DBConnectionManager INSTANCE = new DBConnectionManager();

	private Hashtable<String, DBConnectionPool> pools;
	private String connectionString = "jdbc:mysql://" + rb.getString("DBIP") + 
	"/db_notizverwaltung";	

	private DBConnectionManager(){
		//		load and register driver
		try {
			Class.forName("com.mysql.jdbc.Driver").newInstance();
		} catch (Exception ex) {
			System.out.println("Fehler: " + ex.getMessage());
		}

		pools = new Hashtable<String, DBConnectionPool>();
		System.out.println(connectionString);
		pools.put("db_notizverwaltung", 
				new DBConnectionPool(Integer.parseInt(rb.getString("MAX_CONNECTIONS")),"user","123456",true, connectionString));	
	}

	public static DBConnectionManager getInstance(){
		return INSTANCE;
	}

	public Connection getConnection(String pool){
		Connection c = null;		
		c =((DBConnectionPool) pools.get(pool)).getConnection();
		return c;
	}

	public void putConnection(String pool, Connection con){
		((DBConnectionPool) pools.get(pool)).putConnection(con);
	}
}