package sql;

import java.util.Collection;

import model.Category;
import model.Note;
import model.SearchCriteria;

public class SQLImplementation implements SQL {

	private static SQL sqlInstance;
	
	private SQLImplementation(){
		
	}
	
	public static SQL getInstance(){
		
		if(sqlInstance == null){
			sqlInstance = new SQLImplementation();
		}	
			return sqlInstance;
	}


	public boolean createNote(Note n) {
		return false;
	}

	public boolean deleteNote(Note n, boolean myBoolean) {
		DeleteDAO delDAO = new DeleteDAO();
		return delDAO.deleteNote(n, myBoolean);
	}
	
	public boolean setNoteInactive(int noteID){    
		DeleteDAO delDAO = new DeleteDAO();        
		return delDAO.setNoteInactive(noteID);
	}

	public int saveNote(Note n) {
		SaveDAO saDAO = new SaveDAO();
		try{
			return saDAO.saveNote(n);
		}catch(Exception ex){
			return -2;
		}
	}

	@SuppressWarnings("unchecked")
	public Collection<Note> searchNote(SearchCriteria s) {
		SearchDAO seDAO = new SearchDAO();
		return seDAO.searchNote(s);
	}

	public Category getRootCategory() {
		CategoryDAO caDAO = new CategoryDAO();
		return caDAO.getRootCategory();
	}

	public boolean doLogin(String nickname, String password) {
		UserDAO doLoginDAO = new UserDAO();
		return doLoginDAO.checkLogin(nickname, password);
	}
	
	public void doRegister(String user, String password){
		UserDAO doRegisterDAO = new UserDAO();
		doRegisterDAO.doRegistration(user, password);
	}

	public Note getSimpleNote(int noteID, int versionID) {
		SearchDAO seDAO = new SearchDAO();
		return seDAO.getSimpleNote(noteID, versionID);
	}

	public int getUserIDByUsername(String username) {
		SaveDAO saveDao = new SaveDAO();
		return saveDao.getUserIDByUsername(username);
	}

	public Collection getCategoryList() {
		CategoryDAO categoryDao = new CategoryDAO();
		return categoryDao.getCategoryList();
		
	}
	


}
