package sql;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;

import model.Note;

public class SaveDAO extends DAO{

	final static String SQL_DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";
	int noteid = 0;
	Connection c;

	public int saveNote(Note n){

		//aktuelles Datum in einen String Speichern. Format: "YYYY-MM-DD HH:MIN:SEC"
		String date = formatDate(new Date());
		c = this.getConnection();
		
		try{
			stmt = c.createStatement();
			if(n.getDBID() == 0){				//Kontrolliert ob es eine neue Notiz ist. Bei 0 ist es eine neue Notiz
				n.setIsNewest(1);				//Markiert die Notiz als neuste indem es den Wert 1 im Feld IsNewst setzt
				setMaxNoteversion();			//Fügt der Notiz die nächste neue ID hinzu
			
				commitQuery(n, date, noteid);	//Führt das Savestatement aus.
				commitCategory(n, noteid);
				return noteid;
			}else{
				int versionID = n.getVersionID();
				versionID++;		
				setIsNewestToZero(n);  
				n.setIsNewest(1);
				n.setVersionID(versionID);
		
				commitQuery(n, date, n.getDBID());
				commitCategory(n, n.getDBID());
				return n.getDBID();
			}
		}
		catch(SQLException ex){
			errorQuery(c, ex);
			return -1;	
		}
		finally{
			this.putConnection(c);
		}
	}
	
	private void commitCategory(Note n, int id) throws SQLException{
		stmt.execute("INSERT INTO note_category (FK_NoteID, FK_CategoryID, FK_NoteVersionID) VALUES('"+ id +"','"+n.getSingleCategoryID()+"','"+n.getVersionID()+"')");
		lastCommitState(c);
	}
	
	private boolean commitQuery(Note n, String date, int id) throws SQLException{
		stmt.execute("INSERT INTO noteversion (NoteID, VersionID, Title, Author, Text, Date, Keyword, IsNewest) VALUES('"+ id +"' ,'"+n.getVersionID()+"' ,'"+ n.getTitle() +"' ,'"+ n.getAuthorID() +"' ,'"+ n.getFullText() +"' ,'"+ date +"', '"+ n.getKeyword() +"', '"+n.getIsNewest()+ "')");
		return true;
	}

	public int getUserIDByUsername(String username) {
		c = this.getConnection();
		
		try {
			stmt = c.createStatement();
			String query = "SELECT UserID FROM user WHERE Nickname = '"+ username +"' ";
			ResultSet dbResult = stmt.executeQuery(query);

			while(dbResult.next()){
				return dbResult.getInt("UserID");
			}
			return -1;
		} catch (SQLException e) {
			errorQuery(c, e);
			return -1;
		}finally{
			this.putConnection(c);
		}
	}

	private void setMaxNoteversion() throws SQLException {
		String newSaveStatement ="SELECT MAX(NoteID) FROM noteversion";
		ResultSet res = stmt.executeQuery(newSaveStatement);
		while(res.next()){
			noteid = res.getInt("MAX(NoteID)");
			noteid ++;
		}
	}

	public static String formatDate(Date d) {
		if(null == d){
			return null;
		}
		SimpleDateFormat sd = new SimpleDateFormat(SQL_DATE_FORMAT);
		String date = sd.format(d);
		return date;
	}

	private void setIsNewestToZero(Note n){
		try {
			System.out.println("setIsNewestToZero Test 1");
			stmt.executeUpdate("UPDATE noteversion SET IsNewest = 0 WHERE NoteID = '" + n.getDBID()+"'"); 
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
